// DameController.java                          MM 2009
// MVC-Controller

import java.awt.event.*;             // Listener, Event

/**
 * Controller zum DameView.
 */
public class DameController
  extends WindowAdapter
  implements ActionListener
{
/* ------------------------------------------------- */
                                                 // MVC
/**
 * Mathematisches Model,
 * enthaelt Funktionalitaet des Dameproblems.
 */
  private DameModel model;

/**
 * Zum Controller gehoeriger View.
 */
  private DameView view;

/* ------------------------------------------------- */
                                    // MVC-Installation
/**
 * Konstruktor, initialisiert Model und View.
 * @param model Mathematisches Modell
 * @param view zum Controller gehoeriger View
 */
  public DameController
  ( DameModel model, DameView view)
  {
    this.model = model;
    this.view = view;
  }

/* ------------------------------------------------- */
                                // handleEvent-Methoden
/**
 * ActionListener,
 * Ereignisverarbeitung Betaetigen eines Button.
 */
  public void actionPerformed( ActionEvent ae)
  {
    String command = ae.getActionCommand();


    if( command.equals( view.ACTION_NEU))
    {
        model.reset();
        view.reset();
    }

    if( command.equals( view.ACTION_START))
      model.start();              // Berechnung starten

    if( command.equals( view.ACTION_WEITER))
      view.setBtWeiter();   // naechste Loesung anzeigten

    if( command.equals( view.ACTION_ENDE))
      view.release();              // Programm  beenden
  }

/**
 * WindowAdapter,
 * Ereignisverarbeitung Schliessen des Fensters,
 * Programm wird beendet.
 */
  public void windowClosing( WindowEvent we)
  {
    view.release();
  }

/* ------------------------------------------------- */
                                  // MVC-Deinstallation
/**
 * Freigabe des Controllers,
 * setzt Model und View zurck.
 */
  public void release()
  {
    model = null;
    view = null;
  }
}